#define OPTIMIZE_ROM_CALLS
#define RETURN_VALUE
#define MIN_AMS 101
#define leave(str) {ST_helpMsg(str); push_quantum(NOTHING_TAG); return;}

#include <tigcclib.h>
typedef unsigned long long VLI;	//very long integer

//Check if the ESI pointer is an integer
short is_positive_integer (ESI ptr)
{
  return (*ptr == POSINT_TAG);
}

void merge(int *left, int l_len, int *right, int r_len, int *out)
{
	int i, j, k;
	for (i = j = k = 0; i < l_len && j < r_len; )
		out[k++] = left[i] < right[j] ? left[i++] : right[j++];
 
	while (i < l_len) out[k++] = left[i++];
	while (j < r_len) out[k++] = right[j++];
}
 
void recur(int *buf, int *tmp, int len)
{
	int l = len / 2;
	if (len <= 1) return;

	recur(tmp, buf, l);
	recur(tmp + l, buf + l, len - l);
 
	merge(tmp, l, tmp + l, len - l, buf);
}
 
void merge_sort(int *buf, int len)
{
	int *tmp = malloc(sizeof(int) * len);
	memcpy(tmp, buf, sizeof(int) * len);
 
	recur(buf, tmp, len);
 
	free(tmp);
}

void _main(void)
{
	ESI argptr = top_estack;
	
	//Yhe first argument of the TIOS function is the length of the list
	VLI dimension = GetLongLongArg(argptr); 
	VLI i = 0;
	
	//The dynamic array
	int* array = (int*) malloc(dimension * sizeof(int));
	
	//If the second argument is a list
	if(*argptr == LIST_TAG) 
	{
		//Check if all elements of the list are integers
		//Argptr must be decremented by one to point to first element of the list
		if(!all_tail(is_positive_integer, --argptr))	
		{
			leave("List elements must be integers >= 0.");
		}
		else
			while(i<dimension && *argptr != END_TAG) array[i++]=GetLongLongArg(argptr);
	}
	
	merge_sort(array, dimension);
	
	push_END_TAG();
	for(i=dimension; i>0; i--) push_longlongint(array[i-1]);
	push_LIST_TAG();
}